(function (root) {
  var exports = undefined,
      module = undefined,
      require = undefined;
  var define = undefined;
  (function () {
    let runningEnv = typeof window !== 'undefined' ? window : globalThis;

    runningEnv.HeyGameConfig = function (exports) {
      'use strict';

      class AdConfig {
        constructor() {
          this.appName = "gaishou";
          this.debugMode = true;
          this.appId = ""; //平台获取的appid

          this.heyAppId = 2458; //heygame的appid //todo

          this.heyPlatId = 1044; //heygame平台id

          this.heySecret = "8fe6769830295e9a755b2418a4cef2fb"; // heygame平台秘钥 //todo

          this.versionName = "1.0.0";
          this.resVersion = "1.0.0";
          this.bannerAdUnitId = [""];
          this.interstitialAdUnitId = "";
          this.videoAdUnitId = "";
          this.nativeAdUnitId = [""];
          this.drawerGameAdUnitId = "";
          this.bannerGameAdUnitId = "";
          this.appBoxUnitId = [""];
          this.blockAdUnitId = [""];
          this.shareConfig = {};
        }

      }

      class WXAdConfig extends AdConfig {
        constructor() {
          super();
          this.versionName = "1.0.0";
          this.bannerAdUnitId = ['261277'];
          this.videoAdUnitId = '261289';
        }

      }

      class OPPOAdConfig extends AdConfig {
        constructor() {
          super();
          this.versionName = "1.0.0";
          this.heyPlatId = 1011; //heygame平台id

          this.bannerAdUnitId = ['324783'];
          this.videoAdUnitId = '324784';
          this.nativeAdUnitId = ['435026', '435032', '435035', '435027'];
          this.drawerGameAdUnitId = '324791';
          this.bannerGameAdUnitId = '324790';
        }

      }

      class VIVOAdConfig extends AdConfig {
        constructor() {
          super();
          this.versionName = "1.0.2";
          this.heyPlatId = 1026; //heygame平台id

          this.bannerAdUnitId = ['189ab82b59654611994dedb9979bbde7'];
          this.videoAdUnitId = '17f09bf5695145eb89e373012c19fc90';
          this.interstitialAdUnitId = "2c6fda98b2094579b17e2dde11bcd224";
          this.nativeAdUnitId = ['e35574f041824d4c95aa6120aaa80d81', '592062b93abc428bb0a86331a088a7e9'];
        }

      }

      class TTAdConfig extends AdConfig {
        constructor() {
          super();
          this.versionName = "1.0.1";
          this.heyPlatId = 1020; //heygame平台id

          this.shareConfig = {
            TEMPLATE_ID: "hjm667fja7dibpm6g8",
            title: "快来合作打怪兽",
            desc: "怪兽猎人打怪兽大战"
          };
          this.bannerAdUnitId = ['kp4374il6n6165kpbf'];
          this.videoAdUnitId = 'ii84lccej2b52g6g7k';
          this.interstitialAdUnitId = 'db5klcf0c4j495qaik';
        }

      }

      class QQAdConfig extends AdConfig {
        constructor() {
          super();
        }

      }

      class PCAdConfig extends AdConfig {
        constructor() {
          super();
          this.bannerAdUnitId = [''];
          this.videoAdUnitId = '';
          this.nativeAdUnitId = ['', ''];
          this.drawerGameAdUnitId = '';
          this.bannerGameAdUnitId = '';
        }

      }

      class HeyGameSDKConfig {
        constructor() {
          this._instance = null;
          this._config = null;
          this.initPlatforms();
          this.initSDKConfig();
          console.log('HeyGameSDKConfig constructor');
        }

        static get instance() {
          if (!HeyGameSDKConfig._instance) {
            HeyGameSDKConfig._instance = new HeyGameSDKConfig();
          }

          return HeyGameSDKConfig._instance;
        }

        static get AdConfig() {
          if (!HeyGameSDKConfig.instance._config) {
            HeyGameSDKConfig.instance._config = new AdConfig();
          }

          return HeyGameSDKConfig.instance._config;
        }

        init() {}

        initSDKConfig() {
          if (HeyGameSDKConfig.onWXMiniGame) {
            this._config = new WXAdConfig();
          } else if (HeyGameSDKConfig.onOPPOMiniGame) {
            this._config = new OPPOAdConfig();
          } else if (HeyGameSDKConfig.onVIVOMiniGame) {
            this._config = new VIVOAdConfig();
          } else if (HeyGameSDKConfig.onTTMiniGame) {
            this._config = new TTAdConfig();
          } else if (HeyGameSDKConfig.onQQMiniGame) {
            this._config = new QQAdConfig();
          } else if (HeyGameSDKConfig.onMEIZUMiniGame) {
            this._config = new MEIZUAdConfig();
          } else if (HeyGameSDKConfig.onHWMiniGame) {
            console.error('HeyGameSDKConfig.onHWMiniGame error');
          } else {
            this._config = new PCAdConfig();
          }
        }

        initPlatforms() {
          let u = window.navigator.userAgent;
          console.log('initPlatforms--' + JSON.stringify(u));
          HeyGameSDKConfig.onPC = true; // OPPO mini game

          if (typeof window.qg !== "undefined" && window.qg.getProvider().toLowerCase().indexOf("oppo") > -1) {
            HeyGameSDKConfig.onOPPOMiniGame = true;
            HeyGameSDKConfig.onPC = false;
            return;
          } // VIVO mini game


          if (typeof window.qg !== "undefined" && window.qg.getProvider().toLowerCase().indexOf("vivo") > -1) {
            HeyGameSDKConfig.onVIVOMiniGame = true;
            HeyGameSDKConfig.onPC = false;
            return;
          } // QQ mini game


          if (typeof window.qq !== "undefined") {
            HeyGameSDKConfig.onQQMiniGame = true;
            HeyGameSDKConfig.onPC = false;
            return;
          } // tt mini game


          if (typeof window.tt !== "undefined") {
            HeyGameSDKConfig.onTTMiniGame = true;
            HeyGameSDKConfig.onPC = false;
            return;
          } // meizu mini game


          if (typeof window.mz !== "undefined" && window.mz.getProvider().toLowerCase().indexOf("meizu") > -1) {
            HeyGameSDKConfig.onMEIZUMiniGame = true;
            HeyGameSDKConfig.onPC = false;
            return;
          } // WeiXin mini game


          if (typeof window.wx !== "undefined") {
            HeyGameSDKConfig.onWXMiniGame = true;
            HeyGameSDKConfig.onPC = false;
            return;
          } // HuaWei mini game


          if (typeof window.hbs !== "undefined") {
            HeyGameSDKConfig.onHWMiniGame = true;
            HeyGameSDKConfig.onPC = false;
            return;
          } // 4399 mini game


          if (typeof window.gamebox !== "undefined") {
            HeyGameSDKConfig.onSSJJMiniGame = true;
            HeyGameSDKConfig.onPC = false;
            return;
          } //Android


          if (typeof window.jsb !== "undefined" || typeof window.conch !== "undefined" || window["DBApp"] != null) {
            HeyGameSDKConfig.onAndroidAPK = true;
            HeyGameSDKConfig.onPC = false;
          }
        }

      }

      exports.HeyGameSDKConfig = HeyGameSDKConfig;
      return exports;
    }({});
  }).call(root);
})( // The environment-specific global.
function () {
  if (typeof globalThis !== 'undefined') return globalThis;
  if (typeof self !== 'undefined') return self;
  if (typeof window !== 'undefined') return window;
  if (typeof global !== 'undefined') return global;
  if (typeof this !== 'undefined') return this;
  return {};
}.call(this));